"""                +------------------------------------------------------------------+
                   |             == Ultimately, you must teach yourself. ==           |\
                   |                                                                  |\\
                   |              /^\/^\                                              |\\|
                   |            _|__|  O|        A PYTHON REFERENCE BOOK Ver. 2       |\\|
                   |          /~     \_/ \    (SYNTAX WITH TIPS, TRICKS, AND TRAPS)   |\\|
                   |         |__________/  \                                          |\\|
                   |           \_______      \                                        |\\|
                   |                   `\     \                 \                     |\\|
                   |                     |     |                  \                   |\\|
                   |                    /      /        by          \                 |\\|
                   |                   /     /      M. Stueben        \\              |\\|
                   |                 /      /   mastueben@fcps.edu    \ \             |\\|
                   |                /     /                            \  \           |\\|
                   |              /     /             _----_            \   \         |\\|
                   |             /     /           _-~      ~-_         |   |         |\\|
                   |            (      (        _-~    _--_    ~-_     _/   |         |\\|
                   |             \      ~-____-~    _-~    ~-_    ~-_-~    /          |\\|
                   |               \     ~--______-~                ~-___-~           |\\|
                   |                               (August 26, 2014)                  |\\|
                   +------------------------------------------------------------------+\\|
                    \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\|
                     \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\|
                      -------------------------------------------------------------------+

              1. THE BASIC PYTHON PROGRAM (notes and examples for beginners)...........  1
              2. BIT TWIDDLING.........................................................  6
              3. BOOLEANS (see IF)..................................................... 41
              4. BUILT-IN FUNCTIONS (See MATH FUNCTIONS, NUMBERS, RANDOM and STRINGS).. 30
              5. CLASSES and OOP....................................................... 10
              6. COMPREHENSIONS (See FUNCTIONAL PROGRAMMING)........................... 27
              7. DECIMAL TYPE (see HIGH PRECISION COMPUTING)........................... 39
         ==>  8. DICTIONARIES.......................................................... 14
              9. EVAL (See STRINGS) ................................................... 75
             10. EXCEPTIONS (except and else).......................................... 17
             11. FILES................................................................. 18
             12. FORMATTING OUTPUT (only % and NOT format)............................. 25
             13. FUNCTIONAL PROGRAMMING................................................ 27
             14. FUNCTIONS............................................................. 30
             15. GENERATORS and YIELD.................................................. 34
             16. GRAPHICS and ANIMATION................................................ 35
             17. HIGH PRECISION COMPUTATION (Decimal type)............................. 39
        ==>  18. IF, ELSE, ELIF, and BOOLEAN........................................... 41
             19. IMPORT (See MATH FUNCTIONS)........................................... 57
             20. INPUT and OUTPUT...................................................... 45
             21. LAMBDA (See FUNCTIONAL PROGRAMMING)).................................. 27
             22. LIST COMPREHENSIONS (See FUNCTIONAL PROGRAMMING)...................... 27
        ==>  23. LISTS, TUPLES, and ARRAYS (also see QUEUES)........................... 46
        ==>  24. LOOPS (for and while)................................................. 53
             25. MAP (See FUNCTIONAL PROGRAMMING)...................................... 27
             26. MATH FUNCTIONS (Trig, etc.)........................................... 57
             27. MATRICES (creating and transposing)................................... 58
             28. NUMBERS (int, float, decimal, complex, and their functions)........... 60
             29. QUEUES (also see LISTS)............................................... 65
             30. RANDOM, CHOICE, SHUFFLE, and PERMUTATIONS............................. 67
             31. RECURSION............................................................. 69
             32. SETS.................................................................. 71
             33. SLICING (see LISTS and STRINGS)....................................... 46 and 75
        ==>  34. SORTING............................................................... 73
        ==>  35. STRINGS (also see UNICODE)............................................ 75
             36. TIME, CLOCK, and TIMEIT............................................... 82
             37. Tk GRAPHICS (See GRAPHICS)............................................ 35
             38. TRANSLATE and MAKETRANS............................................... 84
             39. TURTLE GRAPHICS....................................................... 85
             40. TYPE TESTING (both type() and isinstance())........................... 88
             41. UNICODE (UTF-8, ASCII, Latin-1, etc.)................................. 90
             42. VARIABLES............................................................. 92
             43. ZIP................................................................... 94


                                == A SHORT SURVIVAL NOTE TO STUDENTS ==

           +----------------------------------------------------------------------------+
           | Note well: The most common reasons for NOT doing well in a C.S. course are |
           |    a. not putting in enough time, both in practice and review,             |
           |    b. giving up too easily difficult, but solvable problems,               |
           |    c. becoming dependent on the charity of classmates (copying code), and  |
           |    d. sitting next to chatty classmates (the worst!).                      |
           +----------------------------------------------------------------------------+

   A note from a student who failed the 2013-2014 A.I. course: "The main issue I had in AI was my inability to
focus on programming both at home and at school. Although I could understand the concepts quickly, I was
plagued with issues of implementation. I would often avoid starting the program, telling myself I'd get it
done at home, which I would inevitably not do. Even when I would start the program, I would work at the
program until I came to a bug I couldn't figure out after 10 minutes of work, and give up on the program."

   Where to get help with your programs:
    a. the teacher
    b. your classmates (Beware of copying code. After a while you can't code.)
    c. the Internet--e.g., stack Overflow. The official Python documentation can be found by typing "The
       Python Language Reference 3.4" and "The Python documentation 3.4.""
    d. books, such as this one. For an electronic copy, go to http://academics.tjhsst.edu/compsci/ai/. An
       excellent, but advanced, online reference can be found on the Internet by typing "dive into python" (at
       http://www.diveintopython3.net/).

   It is sometimes the case that a student who has fallen behind will feel too embarassed to ask questions,
because the questions will be at such a beginner's level. Don't let this happen to you.
"""
############################################<BEGINING OF PROGRAM>#############################################
def doit(Lst): # List-types are passed by reference.
        avg = sum(Lst)/(len(Lst))
        return max(Lst), min(Lst), avg  # <-- three values returned.
    #-------------------------------------------------------------------------------

def main():
    #---1. import functions the math library.
        from math import cos, pi, sqrt, pow, hypot
        print('cosine =', cos (pi/3))       # output: cosine = 0.5000000000000001
        print('sqrt   =', sqrt(100))        # output: sqrt   = 10.0   <-- a float type.
        print('power  =', pow(10, 3))       # output: power  = 1000.0 <-- a float type.
        print('power  =', 10**3)            # output: power  = 1000   <-- an int  type.
        print('hypot  =', hypot(3,4))       # output: hypot  = 5.0
        print('number =', round(12.345, 2)) # output: number = 12.35

    #---2. Create a random list of 10 digits with a for loop.
        Lst = []
        from random import randint
        for n in range(10):
            Lst.append(randint(0,9))

    #---Use a function to find the max, min, and average of the values in the list.
        maximum, minimum, avg = doit(Lst)
        print('max    =', round(maximum, 3))   # output: max    = 9
        print('min    =', round(minimum, 3))   # output: min    = 0
        print('avg    =', round(avg, 3))       # output: avg    = 3.7

    #---7. Pretty print Lst.
        for n in range(len(Lst)):
           print (round(Lst[n], 2), end = ',') # output: 4,1,1,7,4,4,4,3,0,9,
#-------------------------------------------------------------------------------------------------------------
if __name__ == '__main__':
#====================================<GLOBAL CONSTANTS and GLOBAL IMPORTS>====================================
     from random import random, randint; from math import sqrt; from copy import deepcopy;
     from time import clock; START_TIME = clock(); main(); print('\n      +===<RUN TIME>===+');
     print('      |  %5.2f'%(clock()-START_TIME), 'seconds |'); print('      +================+')
###############################################<END OF PROGRAM>###############################################
"""


                                   == INTRODUCTION TO THE PYTHON LANGUAGE ==

   Welcome to the Python programming language. If you are a novice to all computer programming, then you will
need a beginner's book, not this manual. But if you have learned at least one programming language (loops,
arrays, ifs, graphics, etc.), then studying these notes will get you moving pretty fast in learning Python. I
have tried to put into this document every Python tip, trick, and trap that I know.

   My personal preference is for Python version 3.x, not Python 2.x. Admittedly, some libraries (modules) have
not been re-written from version 2.x and will not work in version 3.x. Personally, I have not found this to be
a disadvantage.

DOWNLOADING THE PYTHON LANGUAGE AND PYTHON EDITORS.
   The easiest Python editor to work with in Windows is the free Pyscripter (my favorite). Pyscripter is
similar to jGRASP, which currently does NOT work with Python. If you use the built-in editor Idle, be aware
that it does not display line numbers, but it does give the line number of the cursor. The arrow keys and the
delete key do not work in Idle (Argg!). Many professionals prefer the free editer called vim (aka vi). This
editor does take some time to master.

   Google "Download Python". Click on "Download Python", not one of the subchoices. Currently choose the
latest version: "Python 3.x Windows x86 MSI Installer". Follow the directions to install. Next download your
editor. For Pyscripter, Google "downloads - Pyscripter". Choose the latest version: PyScripter-v2.x-Setup.exe.
Follow the directions to install.

   To run your Python programs in Pyscripter, just click on the green triangle. The program is automatically
saved at the beginning of every run. To stop an infinite loop, click on the red square. Errors will relocate
the cursor on the line giving the error. Pyscripter responds to the mouse, and the arrow keys. The characters-
per-line are easily modified.  I prefer to clear the output screen before each run (Tools, Options, IDE
Options, Python Interpreter, mark "Clear output before run"). I also prefer to use 110-character lines instead
of the default 80-character lines. (Tools, Options, Editor Options, Set Edge Column to 110).

   If you use KATE for the Linux operating system, then you need to save your program before you run it,
and ALWAYS push F-11 to obtain line numbers.

   Another popular Python editor is Sublime (actually Sublime Text 2 or Sublime Text 3). The Sublime Text
Editor works for almost every important language, has multiple features and even has a Vim emulator. It may be
downloaded and evaluated for free, however a $70 license is expected to be purchased for continued use. There
is no enforced time limit for the evaluation. (Use CTRL B to run your program. Be sure you have the Python
version on your computer that works with the Sublime editor, or else you will get an error message that you
are missing a '.dll' file.)
======================================================**======================================================

ABOUT PYTHON.
   The Python language was originally written by the Dutch computer programmer Guido van Rossum. In a whim-
sical moment, the name "Python" was chosen in reference to the six-member British comedy group known as Monty
Python's Flying Circus (45 TV episodes from 1969 to 1974, and five movies, the last in 1983). According to
Wikipedia, Mr. Rossum currently is employed by Google, where he spends half his time working on Python
development.

   Python (sometimes called CPython, because it was written in C) has been around since 1994 and has gone
through 14 updates. Version 3.4 was released in 2014. Surprisingly, the 3.x versions are NOT backwards com-
patible with 2.x versions. In 2007 and 2010 Python won awards for the computer language that showed the great-
est growth in popularity. (See Wikipedia under Python.) Th languages more popular than Python are Java, C,
C++, and C#.

   Python is almost executable pseudo-code, with many convenient built-in functions, and an especially simple
syntax. Python has been described as BASIC on steroids. You can write programs much quicker and with less code
than in other languages. For example, here is the single line that will swap two values in Python:

                                            a, b = b, a.

   BTW, you will never see an "Unreachable Code" error message in Python. The price for the ease of program
development is loss of speed in execution. In my experience, C++ (which is compiled, not interpreted) executes
about 40-50 times faster than Python, but C++ is much slower to write programs in. Yet, rarely do we notice
that a Python program runs slow. My program to have the computer play one million games of tic-tac-toe against
itself and build a file of good and bad moves took almost 2 minutes to run. That is fast enough.

                               Use the right tool for the right job.

   Python is an interpreted language, not a compiled language. The Python interpreter will first translate the
source code (the Python program you write) into byte code, and save the file. Then a program called the Python
Virtual Machine (PVM) runs the byte code line by line--in effect the PVM runs your program, by turning each
line of byte code into a set of machine instructions and executing the instructions. Unfortunately, when the
PVM encounters the same instruction for a second time, it must re-translate the same byte code into the same
set of machine instructions.

   Python version 3.x has some syntactical changes over Python 2.7. Here are the major differences.

          1. Parentheses are required around all print statements. You can also
             customize the separator (sep = ",") and the final character
             (end = "").
          2. input() is used instead of raw_input().
          3. xrange() has been replaced with range().
          4. We use >, >=, ==, <, <= to compare strings. The compare function
             cmp() is gone.
          5. The long type has been renamed int.
          6. 1/2 = 0.5, and 1//2 = 0. (The symbols have been reversed.)
          7. maketrans() has been replaced by str.maketrans().
          8. The "Tkinter" module has been renamed "tkinter".
======================================================**======================================================

Below are five examples of the same program.

Program 1. This program consists of one line. If you need something quick and dirty, then you don't even need
           a main function.

           +-----------------------------------------------------------------------+
           |  print('Hello World!')                                                |
           +-----------------------------------------------------------------------+

Program 2. You can--and should--have a main function, but then you must call the main function. Scope is
           indicated by indentation, not braces.

           +-----------------------------------------------------------------------------+
           | def main():                                                                 |
           |     print('Hello World!')         # must be indented                        |
           |     print('Hello World, again!')  # must match the exact indentation above. |                                    |
           |                                                                             |
           | main()                                                                      |
           +-----------------------------------------------------------------------------+

Program 3. Below we have a function called from the main function. By the way, if you needed to use this
           message function in anopther program and decided to import this file (instead of cutting and
           pasting the function), then the entire program would be run automatically with a call to the
           function. How strange. And how do we stop this? See the next example.

           +-----------------------------------------------------------------------+
           | def message():                                                        |
           |     return 'Hello World!'                                             |
           |                                                                       |
           | def main():                                                           |
           |     print(message())                                                  |
           |                                                                       |
           | main()                                                                |
           +-----------------------------------------------------------------------+

Program 4. This program is the conventional way to write a Python program. The

                               if __name__ == '__main__' # Note the two double underscores.

           allows a file (containing a useful function) to be called by other programs, without an automatic
           run of the imported program. We rarely need to import a program that has its own main function. We
           usually call libraries (Python modules) with no main functions, or just cut-and-paste. Neverthe-
           less, below is the conventional form used for all Python programs.

           +-----------------------------------------------------------------------+
           | def message():                                                        |
           |     return 'Hello World!'                                             |
           |                                                                       |
           | def main():                                                           |
           |     print(message())                                                  |
           |                                                                       |
           | if __name__ == '__main__': main()                                     |
           +-----------------------------------------------------------------------+

Program 5. When I begin a new program, I often just download an old program, delete some stuff, and change its
           name. This saves time.

   BTW, there are a few built-in functions that do NOT have to be imported. See the Functions section for
more.

          1. round(). The expression round(num, 2) will round num to 2 decimal places. The expression
             round(num) will round to the nearest integer. To truncate, cast as an int--e.g., int(2.3) = 2.

          2. abs() absolute value

          3. max() and min(). These functions work on lists with any number of elements.

          4. sum(). This will sum the numbers in a list.

          5. len(). This function returns the length of a string and the length of a list.

          6. enumerate(). Places the elements of a list into numbered tuples.
#-------------------------------------------------------------------------------------------------------------

COMMENTS. Single-line comments begin with the hash mark (#). Multi-line comments begin and end with the
   triple quotes (double or single).

      print('Hello world!') # This is a single in-line comment.

      '''
      This is one of several multi-line comments.
      This is one of several multi-line comments.
      This is one of several multi-line comments.
      This is one of several multi-line comments.
      '''
      """
      This is one of several multi-line comments.
      This is one of several multi-line comments.
      This is one of several multi-line comments.
      This is one of several multi-line comments.
      """

   Comments are always optional. Some excellent programmers omit comments for code that they believe is self-
documenting. And much of Python is self-documenting. But comments also serve to organize large blocks of code
for the reader.

PRINTING. There are two optional controls in printing: the separator (default = ' ') and the end-of-line
   string (default ='\n').

        print(1,2,3) # 1 2 3      # output: 1 2 3
        print (1,2,3, sep = ' ' ) # output: 1 2 3   <-- default control
        print (1,2,3, sep = ', ') # output: 1, 2, 3 <-- commas are added
        print (1)                 # output: 1
        print (2)                 # output: 2 (underneath the 1)
        print (1, end = ', ')
        print (2)                 # output: 1, 2 (on the sme line as the 1)
        # output from above:




   A cool way to print many of the same characters is shown below.

        print ('HA ' * 5) # output: HA HA HA HA HA
        print ('-'  * 15) # output: ---------------

   Useful is the end-of-line character ('\n'), when you want to force output data onto a new line in the
middle of a single print statement.
#-------------------------------------------------------------------------------------------------------------

   The instruction to halt a program in the middle of a run is exit(). This is useful for debugging. The exit
function can take only a single string. However, a number may be typecast as a string and then concatenated to
the string. Here are three examples.

                        exit()
                        exit('ERROR in function doit()')
                        exit('ERROR with n = ' + str(n))

   Alas, there is no pause-until-any-key-is-pushed function.
#-------------------------------------------------------------------------------------------------------------

   In many languages you can do something like this: print(a = b), and the value for b will be printed, as
well as a taking on the value of b. In other words, the assignment operator returns the value for the
assignment. This does NOT work in Python. Try it and you will get a compiler error.
#-------------------------------------------------------------------------------------------------------------

   The ++ operator does NOT exist in Python. Use this instead: x += 1.
#-------------------------------------------------------------------------------------------------------------
"""




