"""   +=================-=========-=========-=========*=========-=========-=========-=================+
      ||                                       MATH FUNCTIONS                                        ||
      ||                                                                                             ||
      +=================-=========-=========-=========*=========-=========-=========-=================+


   The import statement will import library (aka module) functions into your program. There are three ways to
do this:

          1. import math
             But then you must use math.sin() instead of sin().

          2. from math import *
             Now you can use sin(). However, you just imported ALL the math functions.
             Beware of name crashes (name pollution), the overwriting of names.
             Nevertheless, sometimes you need to do this when you are just learning to
             use a module. BTW, "import *" can NOT be used inside a function.

          3. from math import tan, radians
             This is the preferred way to import. And you can use this form inside a function.

   For a discussion of random number generators, see the random Numbers section of this document.

   Notice that there are two arc-tangent functions: atan(), and atan2(). The one you want, almost always, is
atan2(). Remember to always calculate in radians (they are easier to work with than degrees), but to show
answers in degrees (psychologically, they are more meaningful than radians). The trig functions default to
radians.

                from math import tan, atan, atan2, degrees, radians, sqrt
                x = 1
                y = sqrt(3)
                print(degrees(atan (y/x))) # output = 59.99999999999999
                print(degrees(atan2(y,x))) # output = 59.99999999999999

                print(tan(radians(45)))    # output: 0.9999999999999999
                print(degrees(atan(1)))    # output: 45.0

                print(complex (1))         # output: (1+0j)
                print( (1+2j) + (3 + 4j))  # output: (4+6j)


            The reason (and the only reason) for measuring angles in radians rather than
            degrees is precisely the same as the reason for preferring logarithms in
            base e to common logarithms--namely, that theoretical arguments become much
            simpler.--T.P. Nunn, The Teaching of Algebra, (Longmans, 1923), page 499.

   Type casting is common in Python: int(x), float(x), str(x), list(x), and tuple(x). Below we cast an integer
to a string, to a list, back to a string, and then back to an integer:

                      num = 1234     # = 1234
                      s = str(num)   # = '1234'
                      L = list(s)    # = ['1', '2', '3', '4']
                      s = ''.join(L) # = '1234'
                      num = int(s)   # = 1234
"""