"""   +=================-=========-=========-=========*=========-=========-=========-=================+
      ||                                             ZIP                                             ||
      ||                                                                                             ||
      +=================-=========-=========-=========*=========-=========-=========-=================+


   Below, we zip several lists into one list of tuples and then unzip the list. The zip() function in con-
junction with the * operator can be used to unzip a set of lists. Here is an example.

    x = [1, 2, 3]
    y = [4, 5, 6]
    z = [7, 8, 9, 0]
    zipped = list(zip(x, y, z))
    print (zipped)                  # [(1, 4, 7), (2, 5, 8), (3, 6, 9)], zipped
    print (*zipped)                 #  (1, 4, 7)  (2, 5, 8)  (3, 6, 9),  a matrix transpose!
    print (list(zip(*zipped)))      # [(1, 2, 3), (4, 5, 6), (7, 8, 9)], unzipped

   What if the lists are of different lengths? in that case, the resulting list is truncated in length to the
length of the shortest list.

#--How to transpose a matrix.
   m = [(1,2,3), (4,5,6)]
   print(*m)                   # (1, 2, 3) (4, 5, 6)
   print (list(zip(*m)))       #  [(1, 4), (2, 5), (3, 6)]

#--Another example.
   L1 = [2,4,6,8]                  # 2 + 7 = 9
   L2 = [7,5,3,1]                  # 4 + 5 = 9
   for (x,y) in zip(L1, L2):       # 6 + 3 = 9
       print (x, '+', y, '=', x+y) # 8 + 1 = 9

#--How to build a dictionary with zip.
   keys   = ['A', 'B', 'C']
   values = [ 1 ,  2 ,  3 ]
   D = dict(zip(keys, values))     # dict is a reserved word
   print(D)                        # {'A': 1, 'C': 3, 'B': 2}

#--The built-in function enumerate does something similar to zip.
   L = list(enumerate(keys))
   print(L)                        # [(0, 'A'), (1, 'B'), (2, 'C')]

"""
